
#define BASICATOMPROARC32	//try a 40
#include "..\baplib\baplib.h"
#include "..\baplib\hsio.h"
#include "..\baplib\servo.h"

#define DBG_PIN1	17
#define DBG_PIN2	18
#define DBG_PIN3	19

unsigned char abMsg[]= "Message\n\r";
extern void TestHServo(void);



int main(void)
{
	int i;
	u16 *pw;
	
	bap_initialize();
    // debug stuff
	output(DBG_PIN1);
    output(DBG_PIN2);
	output(DBG_PIN3);

	high(DBG_PIN1);
	low(DBG_PIN2);
	high(DBG_PIN3);
	pause(20);
	toggle(DBG_PIN1);
	toggle(DBG_PIN2);
	toggle(DBG_PIN3);
	pause(20);
	
	IOPrintf(_S_OUT_, I38400, "See if something can print\n\r");
	pause (100);
	enablehserial(1);
	sethserial (1, 38400, 0, 0, 0);
	DBGPrintf("Using DBGPrintf\n\r");


	pw = 0;
	for (i=0; i < 32; i++) {
		DBGPrintf("%4x ", *pw++);
		if ((i & 0x7) == 7)
			DBGPrintf("\n\r");
	}		
	DBGPrintf("\n\r");
	TestHServo();



	enablehserial(2);
	sethserial(2, 62500, 0, 0, 0);
	pause(50);

    MSound(9, 3, 60, 2000, 80, 2250, 100, 2500);

	for (;;) {
#if 0		
		toggle(DBG_PIN1);
		toggle(DBG_PIN2);
		toggle(DBG_PIN3);
		// Now lets try output to debugger...
		hserout(1, (u8*)abMsg, sizeof(abMsg)-1);	// don't need to output NULL.
		hserout(2, (u8*)abMsg, sizeof(abMsg)-1);	// don't need to output NULL.
		pause (50);
		TASerout(16, I9600, 	(char*)abMsg, sizeof(abMsg)-1);	
		TASerout(17, I38400, 	(char*)abMsg, sizeof(abMsg)-1);	
		TASerout(18, I115200, 	(char*)abMsg, sizeof(abMsg)-1);	
#endif		
		pause(150);
	}
	    
   return 0;
}

void TestHServo(void)
{
	DBGPrintf("Before HServoInit\n\r");
	WaitForDBGTransmitComplete();
	
	HServoInit();

	DBGPrintf("After HServoInit\n\r");
	WaitForDBGTransmitComplete();

	// Next lets simply do a few HSERVOS and see what we get
	toggle(DBG_PIN1);
	HServoGroupMoveStart();
	HServo(8, 500);					
	HServo(9,1500);
	HServo(1, 1800);
	HServo(11, 800);
	HServo(24, 1650);
//	HServo(31, 1400);
	HServoGroupMoveCommit(0);		

	DBGPrintf("After HServo\n\r");
	WaitForDBGTransmitComplete();

	toggle(DBG_PIN1);
	pause (100);

	HServoGroupMoveStart();
	HServo(8, 2500);					
	HServoGroupMoveCommit(500);		
	toggle(DBG_PIN1);
	pause (600);

	HServoGroupMoveStart();
	HServo(8, 1500);					
	HServoGroupMoveCommit(500);		
	toggle(DBG_PIN1);
}	
